#!/bin/sh
# Subnet Configuration Webadmin Script
# Author: Claudio Roberto Cussuol
. /var/http/web-functions
SCRIPT="subnet.cgi"
FILE="/etc/coyote/subnet.cfg"
TMPFILE="/etc/coyote/subnettemp"
COLOR="row6"
#==================================
output_line() {
  echo "<tr>"
  if [ "$DACTIVE" = "Yes" ] ; then
    MyC="row4"
  else
    MyC="row5"
  fi
  echo "<td class=$MyC>$DACTIVE</td>"
  echo "<td class=$COLOR>$ID</td>"
  echo "<td class=$COLOR>$IP</td>"
  echo "<td class=$COLOR>$MASK</td>"
  echo "<td class=$COLOR>$DDHCP</td>"
  echo "<td class=$COLOR>$DQOS</td>"
  echo "<td class=$COLOR nowrap>$DDOWN_RATE</td>"
  echo "<td class=$COLOR nowrap>$DDOWN_CEIL</td>"
  echo "<td class=$COLOR nowrap>$DUP_RATE</td>"
  echo "<td class=$COLOR nowrap>$DUP_CEIL</td>"
  echo "<td class=$COLOR nowrap>$DCOMMENT</td>"
  echo "<td class=$COLOR nowrap><a href=$SCRIPT?ACTION=CALL_EDIT&LINE=$LINECOUNT>&nbsp;[$Faf]&nbsp;</a><a href=$SCRIPT?ACTION=DELETE&LINE=$LINECOUNT>&nbsp;[$Fae]&nbsp;</a></td></tr>"
  if [ "$COLOR" = "row6" ] ; then COLOR="row8"; else COLOR="row6"; fi
}
#==================================
treat_rate() {
  DRATE=
  NRATE=
  SRATE=
  case $1 in
    '$COMP_DOWN')
    	SRATE="$Pha"
    	DRATE=$SRATE ;;
    '$COMP_UP')
    	SRATE="$Phb"
    	DRATE=$SRATE ;;
    '$CLEAR_DOWNSTREAM')
    	SRATE="$Phc"
    	DRATE=$SRATE ;;
    '$CLEAR_UPSTREAM')
    	SRATE="$Phd"
    	DRATE=$SRATE ;;
    *)
        NRATE=$1
	DRATE="$1 kbit/s" ;;
  esac
}
#==================================
treat_line() {
  ACTIVE=$2
  ID=$3
  IP=$4
  MASK=$5
  DHCP=$6
  QOS=$7
  ACTIVE=`echo $ACTIVE | tr [A-Z] [a-z]`
  DHCP=`echo $DHCP | tr [A-Z] [a-z]`
  QOS=`echo $QOS | tr [A-Z] [a-z]`
  if [ $QOS = "y" ] ; then
    DOWN_RATE=$8
    DOWN_CEIL=$9
    UP_RATE=$10
    UP_CEIL=$11
    treat_rate $DOWN_RATE
    DDOWN_RATE=$DRATE
    NDOWN_RATE=$NRATE
    SDOWN_RATE=$SRATE
    treat_rate $DOWN_CEIL
    DDOWN_CEIL=$DRATE
    NDOWN_CEIL=$NRATE
    SDOWN_CEIL=$SRATE
    treat_rate $UP_RATE
    DUP_RATE=$DRATE
    NUP_RATE=$NRATE
    SUP_RATE=$SRATE
    treat_rate $UP_CEIL
    DUP_CEIL=$DRATE
    NUP_CEIL=$NRATE
    SUP_CEIL=$SRATE
  else
    DOWN_RATE=
    DOWN_CEIL=
    UP_RATE=
    UP_CEIL=
    DDOWN_RATE=$Psk
    DDOWN_CEIL=$Psk
    DUP_RATE=$Psk
    DUP_CEIL=$Psk
  fi
  COMMENT=`echo $TMPLINE | sed s/.*#//`
  [ "$COMMENT" = "$TMPLINE" ] && COMMENT=""
  DCOMMENT=$COMMENT
  if [ "$ACTIVE" = "y" ] ; then DACTIVE="Yes" ; else DACTIVE="No"; fi
  if [ "$DHCP" = "y" ] ; then DDHCP="Yes" ; else DDHCP="No"; fi
  if [ "$QOS" = "y" ] ; then DQOS="Yes" ; else DQOS="No"; fi
  LASTID=$ID
  LASTMASK=$MASK
}
#==================================
mount_configuration() {
  DOWN_RATE=$FORM_NDOWN_RATE
  DOWN_CEIL=$FORM_NDOWN_CEIL
  UP_RATE=$FORM_NUP_RATE
  UP_CEIL=$FORM_NUP_CEIL
  [ -z $DOWN_RATE ] && DOWN_RATE='$'$FORM_SDOWN_RATE
  [ -z $DOWN_CEIL ] && DOWN_CEIL='$'$FORM_SDOWN_CEIL
  [ -z $UP_RATE ] && UP_RATE='$'$FORM_SUP_RATE
  [ -z $UP_CEIL ] && UP_CEIL='$'$FORM_SUP_CEIL
  CONFIG_LINE="subnet $FORM_ACTIVE $FORM_ID $FORM_IP $FORM_MASK $FORM_DHCP $FORM_QOS $DOWN_RATE $DOWN_CEIL $UP_RATE $UP_CEIL #$FORM_COMMENT"
}
#==================================
show_list() { #<td align="center" ><b>Line#</td>
cat << CLEOF
<table class=maintable border=0 width="100%"><tr><th colspan=12>$Psg</th></tr>
<tr><td class=header>$Faj</td>
<td class=header>$Psh</td>
<td class=header>$Aip</td>
<td class=header>$Anm</td>
<td class=header>$Psi</td>
<td class=header>$Psj</td>
<td class=header>$Phi</td><td class=header>$Phj</td>
<td class=header>$Phk</td><td class=header>$Phl</td>
<td class=header>$Fad</td><td class=header>$Fac</td></tr>
CLEOF
LINECOUNT=0
cat $FILE | tr [\\] [\|] | while read TMPLINE; do
  LINECOUNT=$(($LINECOUNT+1))
  case "$TMPLINE" in
    \#*|"")
      continue ;;
    subnet*)
      treat_line $TMPLINE
      output_line ;;
  esac
done
cat << CLEOF
</table><br>
<table class=maintable>
<tr><td class=row1><b>$Pid</b></td><td class=row2>[ &nbsp;<a href=$SCRIPT?ACTION=CALL_ADD><u>$Psl</u></a>&nbsp; | &nbsp;
<a href="editconf.cgi?CONFFILE=$FILE&DESCFILE=Subnet Configuration File"><u>$Psm</u></a>&nbsp; ]</td></tr>
</table></form>
CLEOF
}
#==================================
show_form() {
FORMTITLE="$Psg"
if [ -z "$ID" ] ; then
  LASTLINE=`grep subnet $FILE | tail -n 1`
  [ -n "$LASTLINE" ] && treat_line $LASTLINE
  ID=$(($LASTID+1))
  IP=
fi
[ -z "$DOWN_RATE" ] && NDOWN_RATE='' && SDOWN_RATE='Individual Download'
[ -z "$DOWN_CEIL" ] && NDOWN_CEIL='' && SDOWN_CEIL='Total Download'
[ -z "$UP_RATE" ] && NUP_RATE='' && SUP_RATE='Individual Upload'
[ -z "$UP_CEIL" ] && NUP_CEIL='' && SUP_CEIL='Total Upload'
cat << CLEOF
<form method="POST" action="$SCRIPT">
<input type=hidden value="$LINE" name=LINE>
<input type=hidden value="$ACTION" name=ACTION>
<table class=maintable width=100%><tr><th colspan=2>$FORMTITLE</th></tr>
<tr><td class=row1 align=right><b>$Paz</b><br>$Pba</td>
    <td class=row2><input type=radio value=n name=ACTIVE `[ "$ACTIVE" = "n" ] && echo checked`>$Fno &nbsp;<input type=radio value=y name=ACTIVE `[ "$ACTIVE" != "n" ] && echo checked`>$Fye</td></tr>
<tr><td class=row1 align=right><b>$Psh</b><br><small>$Psn</small></td>
    <td clas=row2><input type=text name=ID value="$ID" size=10></td></tr>
<tr><td class=row1 align=right><b>$Aip</b><br><small>$Pso</small></td>
    <td class=row2><input type=text name=IP value="$IP" size=20></td></tr>
<tr><td class=row1 align=right><b>$Anm</b><br><small>$Psp</small></td>
    <td class=row2><input type=text name=MASK value="$MASK" size=20></td></tr>
<tr><td class=row1 align=right><b>$Psi</b><br>$Psq</td>
    <td class=row2><input type=radio value=n name=DHCP `[ "$DHCP" = "n" ] && echo checked`>$Fno &nbsp;<input type=radio value=y name=DHCP `[ "$DHCP" != "n" ] && echo checked`>$Fye</td></tr>
<tr><td class=row1 align=right><b>$Psj</b><br>$Psr</td>
    <td class=row2><input type=radio value=n name=QOS `[ "$QOS" = "n" ] && echo checked`>$Fno &nbsp;<input type=radio value=y name=QOS `[ "$QOS" != "n" ] && echo checked`>$Fye</td></tr>
<tr><td class=row1 align=right><b>$Phi</b><br><small>$Phv  $Phw</small></td><td class=row2><input type=text name=NDOWN_RATE value="$NDOWN_RATE" size=4>&nbsp; kbits/s $Far<br>
 <select name=SDOWN_RATE><option value></option><option value='COMP_DOWN' `[ "$SDOWN_RATE" = "Individual Download" ] && echo selected`>$Phx</option>
 <option value='CLEAR_DOWNSTREAM' `[ "$SDOWN_RATE" = "Total Download" ] && echo selected`>$Phy</option></select></td></tr>
<tr><td class=row1 align=right><b>$Phj</b><br><small>$Phz  $Phw</small></td><td class=row2><input type=text name=NDOWN_CEIL value="$NDOWN_CEIL" size=4>&nbsp; kbits/s $Far<br>
 <select name=SDOWN_CEIL><option value></option><option value='COMP_DOWN' `[ "$SDOWN_CEIL" = "Individual Download" ] && echo selected`>$Phx</option>
 <option value='CLEAR_DOWNSTREAM' `[ "$SDOWN_CEIL" = "Total Download" ] && echo selected`>$Phy</option></select></td></tr>
<tr><td class=row1 align=right><b>$Phk</b><br><small>$Phv  $Phw</small></td><td class=row2><input type=text name=NUP_RATE value="$NUP_RATE" size=4>&nbsp; kbits/s $Far<br>
 <select name=SUP_RATE><option value></option><option value='COMP_UP' `[ "$SUP_RATE" = "Individual Upload" ] && echo selected`>$Phb</option>
 <option value='CLEAR_UPSTREAM' `[ "$SUP_RATE" = "Total Upload" ] && echo selected`>$Phd</option></select></td></tr>
<tr><td class=row1 align=right><b>$Phl</b><br><small>$Phz  $Phw</small></td><td class=row2><input type=text name=NUP_CEIL value="$NUP_CEIL" size=4>&nbsp; kbits/s $Far<br>
 <select name=SUP_CEIL><option value></option><option value='COMP_UP' `[ "$SUP_CEIL" = "Individual Upload" ] && echo selected`>$Phb</option>
 <option value='CLEAR_UPSTREAM' `[ "$SUP_CEIL" = "Total Upload" ] && echo selected`>$Phd</option></select></td></tr>
<tr><td class=row1 align=right><b>$Fad ($Fop)</b><br><small>$Pss</small></td><td class=row2><input type=text name=COMMENT value="$COMMENT" size=30></td></tr>
</table><p align=center><input type=submit value="$Fsb" name=OKBTN>&nbsp;<input type=reset value="$Fer"></p>
</form>
CLEOF
}
#==================================
# MAIN ROUTINE
cl_header2 "$Psg - BrazilFW"
if [ "$FORM_OKBTN" = "$Fsb" ]; then
   mount_configuration
   if [ -n "$CONFIG_LINE" ] ; then
     if [ "$FORM_ACTION" = "ADD" ]; then
        echo -e $CONFIG_LINE >> $FILE
     else
       LINECOUNT=0
       echo -n > $TMPFILE
       cat $FILE | tr [\\] [\|] | while read TMPLINE; do
         LINECOUNT=$(($LINECOUNT+1))
         if [ "$LINECOUNT" -ne "$FORM_LINE" ] ; then
           echo "$TMPLINE" >> $TMPFILE
         else
           echo $CONFIG_LINE >> $TMPFILE
         fi
       done
       rm -f $FILE
       mv $TMPFILE $FILE
       touch /tmp/need.save
     fi
     echo "<center><div id=back>$Pst<br>"
     echo "<a href=backup.cgi>$Wtl</a><br>"
     echo "<a href=reboot.cgi>$Psv</a></div></center><br>"
   fi
fi

case "$FORM_ACTION" in
  "DELETE")
     LINECOUNT=0
     echo -n > $TMPFILE
     cat $FILE | tr [\\] [\|] | while read TMPLINE; do
       LINECOUNT=$(($LINECOUNT+1))
       if [ "$LINECOUNT" -ne "$FORM_LINE" ] ; then
         echo "$TMPLINE" >> $TMPFILE
       fi
     done
     rm -f $FILE
     mv $TMPFILE $FILE
     touch /tmp/need.save
     echo "<center><div id=back>$Psu<br>"
     echo "<a href=backup.cgi>$Wtl</a><br>"
     echo "<a href=reboot.cgi>$Psv</a></div></center><br>"
     show_list
     ;;
   "CALL_EDIT")
     TMPLINE=`head -n $FORM_LINE $FILE | tail -n 1`
     treat_line $TMPLINE
     ACTION="EDIT"
     LINE=$FORM_LINE
     show_form
     ;;
   "CALL_ADD")
     METHOD=$FORM_METHOD
     ACTION="ADD"
     LINE=0
     show_form
     ;;
   *)
     show_list
     ;;
esac
cl_footer2
